PFont hel;

Table table;
float[][] bookMatrix = null;
int[] dewey;
String[] deweyType;
String[] itemType;
int[] verticalDistanceOne;
int[] verticalDistanceTwo;
int minimum = 2000;

int numRows, numCols;

void setup() {
  size(1280,720);
  background(230);
  
  hel = loadFont("Calibri-48.vlw");
  textFont(hel);
  
  table = loadTable("ForgottenBooks.csv");
  numRows = table.getRowCount();
  numCols = table.getColumnCount();

  bookMatrix = new float[numRows-1][numCols-1];
  dewey = new int[numRows-1];
  deweyType = new String[numRows-1];
  itemType = new String[numCols-1];
  verticalDistanceOne = new int[numRows-1];
  verticalDistanceTwo = new int[numCols-1];
  
  for(int k=1; k<numCols; k++){
    itemType[k-1] = table.getString(0,k); 
  }
  
  for(int i=1; i<numRows; i++){
    for(int j=0; j<numCols; j++){
      if(j == 0){
        dewey[i-1] = table.getInt(i,j);
        if(dewey[i-1] == 900){
          deweyType[i-1] = "History & Geography";
        }
        if(dewey[i-1] == 800){
          deweyType[i-1] = "Literature";
        }
        if(dewey[i-1] == 700){
          deweyType[i-1] = "Arts & Recreation";
        }
        if(dewey[i-1] == 600){
          deweyType[i-1] = "Technology";
        }
        if(dewey[i-1] == 500){
          deweyType[i-1] = "Pure Science";
        }
        if(dewey[i-1] == 400){
          deweyType[i-1] = "Language";
        }
        if(dewey[i-1] == 300){
          deweyType[i-1] = "Social Sciences";
        }
        if(dewey[i-1] == 200){
          deweyType[i-1] = "Religion";
        }
        if(dewey[i-1] == 100){
          deweyType[i-1] = "Philosophy and Psychology";
        }
        if(dewey[i-1] == 0){
          deweyType[i-1] = "General, CS & Info";
        }
      }
      else{
        bookMatrix[i-1][j-1] = table.getInt(i,j);
        if(bookMatrix[i-1][j-1] < minimum){
          bookMatrix[i-1][j-1] = minimum + random(-300,300);
        }
      }
    }
  }

  //Dawing on canvas
  fill(0);
  textSize(12);
  for(int i=0; i<numRows-1; i++){
    verticalDistanceOne[i] = 120 + 60 * i;
    textAlign(RIGHT);
    text(deweyType[i], 140, verticalDistanceOne[i]);
  } 
  
  for(int j=0; j<numCols-1; j++){
    verticalDistanceTwo[j] = 100 + 60 * j;
    textAlign(LEFT);
    text(itemType[j], width-90, verticalDistanceTwo[j]);
  }
  
  textSize(30);
  textAlign(CENTER);
  text("Forgotten Books", width/2, 30);
  textSize(12);
  text("(Books has been checked out for more than 36 years)", width/2, 45);
  
  translate(width/2, height/2);
  fill(#4A88DE,50); 
  for(int i=0; i<numRows-1; i++){
    for(int j=0; j<numCols-1; j++){
      if(bookMatrix[i][j] > 0){
        stroke(20,100);
        float xRect = randomGaussian()*120;
        float yRect = randomGaussian()*120;  
        if(bookMatrix[i][j] > 1000){
          rect(xRect,yRect,bookMatrix[i][j]/500,bookMatrix[i][j]/500);
          stroke(20,20);
          line(140 - width/2, verticalDistanceOne[i] - height/2 - 3.5, xRect, yRect);
          line(width-90-width/2, verticalDistanceTwo[j]-height/2 -3.5, xRect + bookMatrix[i][j]/500, yRect + bookMatrix[i][j]/500);
        }
      }
    }
  } 
}
  
 
